
#include "stdafx.h"
#include "DES_RenderMeshRMP.h"
#include "DESSamplePlugin.h"

CDES_RenderMeshRMP::CDES_RenderMeshRMP(void)
{
}

CDES_RenderMeshRMP::~CDES_RenderMeshRMP(void)
{
}

UUID CDES_RenderMeshRMP::PlugInId(void) const
{
	return DESSamplePlugIn().PlugInID();
}

UUID CDES_RenderMeshRMP::ProviderId(void) const
{
	// !!!! DO NOT REUSE THIS UUID !!!!
	// !!!! DO NOT REUSE THIS UUID !!!!
	// !!!! DO NOT REUSE THIS UUID !!!!
	// !!!! DO NOT REUSE THIS UUID !!!!
	static const UUID uuid =
	{
      // {A72C7643-8953-49FD-AF53-124D9A5FC903}
      0xa72c7643, 0x8953, 0x49fd,{ 0xaf, 0x53, 0x12, 0x4d, 0x9a, 0x5f, 0xc9, 0x3 }
	};
	// !!!! DO NOT REUSE THIS UUID !!!!
	// !!!! DO NOT REUSE THIS UUID !!!!
	// !!!! DO NOT REUSE THIS UUID !!!!
	// !!!! DO NOT REUSE THIS UUID !!!!

	return uuid;
}

ON_wString CDES_RenderMeshRMP::Name(void) const
{
  const static ON_wString wszName = L"SampleCustomRenderMeshProvider";
  return wszName;
}

bool CDES_RenderMeshRMP::WillBuildCustomMesh(const ON_Viewport& vp, const CRhinoObject* pObject, const CRhinoDoc&,
                                                  const UUID&, const CDisplayPipelineAttributes*) const
{
  if (nullptr == pObject)
    return false;

  const ON_Brep* Brep = ON_Brep::Cast(pObject->Geometry());
  if (Brep) return true;

  return false;
}

ON_BoundingBox CDES_RenderMeshRMP::BoundingBox(const ON_Viewport& vp, const CRhinoObject* pObject, const CRhinoDoc& doc,
                                        const UUID& uuidRequestingPlugIn, const CDisplayPipelineAttributes* pAttributes) const
{
    if (nullptr == pObject)
      return ON_BoundingBox::EmptyBoundingBox;

    ON_BoundingBox bb = pObject->BoundingBox();
    bb.m_max = bb.m_max - 0.5 * ON_3dVector::ZAxis;
    bb.m_min = bb.m_min - 0.5 * ON_3dVector::ZAxis;
    return bb;
}

bool CDES_RenderMeshRMP::BuildCustomMeshes(const ON_Viewport& vp, const UUID& uuidRequestingPlugIn, const CRhinoDoc& doc,
                                                IRhRdkCustomRenderMeshes& crmInOut, const CDisplayPipelineAttributes* pAttributes,
                                                bool bWillBuildCustomMeshCheck) const

{
  const CRhinoObject* pObject = crmInOut.Object();
  if (nullptr == pObject)
    return false;

  if (bWillBuildCustomMeshCheck)
  {
    if (!WillBuildCustomMesh(vp, pObject, doc, uuidRequestingPlugIn, pAttributes))
    {
      return false;
    }
  }

  const ON_Brep* Brep = ON_Brep::Cast(pObject->Geometry());
  if (!Brep) return false;
  ON_BrepFace* F = Brep->Face(0);
  const ON_Surface* Sur = *Brep->m_S.At(0);

  ON_SimpleArray<const ON_Mesh*> renderMeshes;
  if (pObject->GetMeshes(ON::render_mesh, renderMeshes) > 0)
  {
    for (int mi = 0; mi < renderMeshes.Count(); mi++)
    {
      crmInOut.SetUseObjectsMappingChannels(false);
      crmInOut.SetInstanceTransform(ON_Xform::IdentityTransformation);
      crmInOut.SetAutoDeleteMeshesOn();
      crmInOut.SetAutoDeleteMaterialsOn();
      ON_Mesh* pMesh = new ON_Mesh(*renderMeshes[mi]);
      if (nullptr != pMesh)
      {
        //pMesh->Transform(ON_Xform::TranslationTransformation(1.5 * ON_3dVector::ZAxis));
        //Move Vertex positoin
        ON_3fPointArray Vertex = pMesh->m_V;
        ON_2dPointArray pars = pMesh->m_S;
        for (int i = 0; i < Vertex.Count(); i++)
        {
          ON_3fPoint* p3f = Vertex.At(i);
          ON_2dPoint par = *pars.At(i);
          //ON_3dVector vec = ON_zaxis;
          ON_3dVector vec = Sur->NormalAt(par.x, par.y);
          vec.Unitize(); vec = vec * 1.5;
          p3f->x = p3f->x + float(vec.x);
          p3f->y = p3f->y + float(vec.y);
          p3f->z = p3f->z + float(vec.z);
        }
        pMesh->m_V = Vertex;
      }
      crmInOut.Add(pMesh, nullptr);
    }
  }
  return true;
}
